'*******************************************************************************
'	Filename   : CodeV_quick_beautifier.vbs
'	Created    : 2013
'	Created by : Franois RIGUET
'	Comments   : indents according options and control statements
' You can freely distribute this script, but please keep this header intact
' Version 1.1 : added UCH option
'*******************************************************************************

Option Explicit

Const MODULE_NAME  = "CodeV_quick_beautifier"
Const MODULE_VER   = "1.1"
Const MODULE_TITLE = "Code V quick beautifier" 

Sub Init
    addMenuItem "Code V quick beautifier", "", "CodeV_quick_beautifier", "CTRL+SHIFT+I"
End Sub


Sub CodeV_quick_beautifier()
	Dim button, editor, indent_counter, line, str, counter, indent_comment
	Dim regExIndent_control, regExIndent_option, regExUnindent_option, regExUnindent_control, regExIndent_else_control, regEx_comment
	Dim found_indent_control, found_indent_option, found_unindent_option, found_unindent_control, found_indent_else_control, found_comment
	Set editor = newEditor()
	editor.assignActiveEditor
	
	button = MsgBox ("Before indenting you should delete all the indentation." &vbCr &"Tick the first box only in the next dialog.") ', vbOKCancel)
' 	If button = 2 Then Exit Sub

	runPSPadAction "aRemoveSpaces"	

	indent_comment = 0
	
	indent_counter = 0
	
	for line = 1 to editor.linesCount() 
		editor.caretx(1)
		editor.carety(line)
		str = editor.lineText()

		Set regExIndent_control = New RegExp    
		regExIndent_control.Pattern = "^\bIF\b|^\bFOR\b|^\bWHI\b|^\bUNT\b|^\bFCT\b|^\bGRO\b|^\bMIC\b"        
		regExIndent_control.IgnoreCase = True    
		regExIndent_control.Global = True      
		found_indent_control = regexIndent_control.test(str)

		Set regExIndent_else_control = New RegExp    
		regExIndent_else_control.Pattern = "^\bELS\b"        
		regExIndent_else_control.IgnoreCase = True    
		regExIndent_else_control.Global = True      
		found_indent_else_control = regexIndent_else_control.test(str)

		Set regExIndent_option = New RegExp    
		regExIndent_option.Pattern = "^\bALI\b|^\bANA\b|^\bAUT\b|^\bBEA\b|^\bBIO\b|^\bBPR\b|\bBSP\b|^\bCAM\b|^\bCAT\b|^\bCEF\b|^\bCOS\b|^\bCXP\b|^\bELE\b|^\bENV\b|^\bFAB\b|^\bFIE\b|^\bFMA\b|^\bFOO\b|^\bFOV\b|^\bGDE\b|^\bGHO\b|^\bGLD\b|^\bGLS\b|^\bIMS\b|^\bLIB\b|^\bLSF\b|^\bLTE\b|^\bLUM\b|^\bMTF\b|^\bMUL\b|^\bNAR\b|^\bPAR\b|^\bPMA\b|^\bPSF\b|^\bQUA\b|^\bRAD\b|^\bRIM\b|^\bSLD\b|^\bSPE\b|^\bSPO\b|^\bSSS\b|^\bTES\b|^\bTOD\b|^\bTOL\b|^\bTOR\b|^\bTRA\b|^\bUCH\b|^\bUGR\b|^\bV3D\b|^\bVIE\b|^\bWAV\b|^\bWEI\b|^\bPRV\b|^\bMAU\b|^\bMCH\b|^\bMLI\b|^\bMPL\b|^\bMTO\b"        
		regExIndent_option.IgnoreCase = True    
		regExIndent_option.Global = True      
		found_indent_option = regexIndent_option.test(str)

		Set regExUnindent_option = New RegExp    
		regExUnindent_option.Pattern = "\bGO\b|\bMEX\b"        
		regExUnindent_option.IgnoreCase = True    
		regExUnindent_option.Global = True      
		found_unindent_option = regexUnindent_option.test(str)

		Set regExUnindent_control = New RegExp    
		regExUnindent_control.Pattern = "\bEND\b"        
		regExUnindent_control.IgnoreCase = True    
		regExUnindent_control.Global = True      
		found_unindent_control = regexUnindent_control.test(str)

		Set regEx_comment = New RegExp    
		regEx_comment.Pattern = "^!"        
		regEx_comment.IgnoreCase = True    
		regEx_comment.Global = True      
		found_comment = regex_comment.test(str)

		if found_comment then
			if indent_comment then
				counter = indent_counter
				do until counter = 0 
					editor.command("ecTab") 
					counter = counter - 1 
				loop
			end if
		else
			if (found_indent_control and not(found_unindent_control) and not(found_indent_else_control)) then
				counter = indent_counter
				do until counter = 0 
					editor.command("ecTab") 
					counter = counter - 1 
				loop
				indent_counter = indent_counter + 1
			elseif found_unindent_control then
				indent_counter = indent_counter - 1
				if indent_counter = -1 then 
					button = MsgBox ("A la ligne" & line & "le compteur d'indentation est ngatif." &vbCr &"Le compteur d'indentation va tre remis  0." , vbExclamation)
					indent_counter = 0
				end if
				counter = indent_counter
				do until counter = 0 
					editor.command("ecTab") 
					counter = counter - 1 
				loop
			elseif found_indent_else_control then
				indent_counter = indent_counter - 1
				if indent_counter = -1 then 
					button = MsgBox ("A la ligne" & line & "le compteur d'indentation est ngatif." &vbCr &"Le compteur d'indentation va tre remis  0." , vbExclamation)
					indent_counter = 0
				end if
				counter = indent_counter
				do until counter = 0 
					editor.command("ecTab") 
					counter = counter - 1 
				loop
				indent_counter = indent_counter + 1
			elseif (found_indent_option and not(found_unindent_option)) then
				counter = indent_counter
				do until counter = 0 
					editor.command("ecTab") 
					counter = counter - 1 
				loop
				indent_counter = indent_counter + 1
			elseif (found_indent_option and found_unindent_option) then
				counter = indent_counter
				do until counter = 0 
					editor.command("ecTab") 
					counter = counter - 1 
				loop
			elseif (found_unindent_option and not(found_indent_option)) then
				indent_counter = indent_counter - 1
				if indent_counter = -1 then 
					button = MsgBox ("A la ligne" & line & "le compteur d'indentation est ngatif." &vbCr &"Le compteur d'indentation va tre remis  0." , vbExclamation)
					indent_counter = 0
				end if
				counter = indent_counter
				do until counter = 0 
					editor.command("ecTab") 
					counter = counter - 1 
				loop
			else 
				counter = indent_counter
				do until counter = 0 
					editor.command("ecTab") 
					counter = counter - 1 
				loop
			end if
		end if
	next
	if indent_counter <> 0 then 
		button = MsgBox ("Indentation counter is not 0 at the end of the macro.", vbExclamation)
	end if

	runPSPadAction "aRemoveRedundantBlank"
	
	runPSPadAction "aCodeFormat" 

End Sub
